"""Add more sample fields and tables

Revision ID: 20f169ee6541
Revises: df9b39f7960f
Create Date: 2016-09-22 09:52:59.010133

"""

# revision identifiers, used by Alembic.
revision = '20f169ee6541'
down_revision = 'df9b39f7960f'

from alembic import op
import sqlalchemy as sa


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.create_table('families',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('genuses',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('orders',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.add_column(u'samplescans', sa.Column('family_id', sa.Integer(), nullable=True))
    op.add_column(u'samplescans', sa.Column('genus_id', sa.Integer(), nullable=True))
    op.add_column(u'samplescans', sa.Column('order_id', sa.Integer(), nullable=True))
    op.create_foreign_key(None, 'samplescans', 'orders', ['order_id'], ['id'])
    op.create_foreign_key(None, 'samplescans', 'genuses', ['genus_id'], ['id'])
    op.create_foreign_key(None, 'samplescans', 'families', ['family_id'], ['id'])
    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(None, 'samplescans', type_='foreignkey')
    op.drop_constraint(None, 'samplescans', type_='foreignkey')
    op.drop_constraint(None, 'samplescans', type_='foreignkey')
    op.drop_column(u'samplescans', 'order_id')
    op.drop_column(u'samplescans', 'genus_id')
    op.drop_column(u'samplescans', 'family_id')
    op.drop_table('orders')
    op.drop_table('genuses')
    op.drop_table('families')
    ### end Alembic commands ###
