"""Add Process to model relationship between datasets

Revision ID: 6867197a0fb9
Revises: afb368fbe1ad
Create Date: 2016-09-28 11:35:42.201089

"""

# revision identifiers, used by Alembic.
revision = '6867197a0fb9'
down_revision = 'afb368fbe1ad'

from alembic import op
import sqlalchemy as sa


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('processes', schema=None) as batch_op:
        batch_op.add_column(sa.Column('destination_id', sa.Integer(), nullable=True))
        batch_op.add_column(sa.Column('source_id', sa.Integer(), nullable=True))
        batch_op.create_foreign_key('datasets.destination_id', 'datasets', ['destination_id'], ['id'])
        batch_op.create_foreign_key('datasets.source_id', 'datasets', ['source_id'], ['id'])

    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table('processes', schema=None) as batch_op:
        batch_op.drop_constraint('datasets.destination_id', type_='foreignkey')
        batch_op.drop_constraint('datasets.source_id', type_='foreignkey')
        batch_op.drop_column('source_id')
        batch_op.drop_column('destination_id')

    ### end Alembic commands ###
